package com.antoniofrische.perifericosAdvisor;

import java.util.ArrayList;
import java.util.Collection;
import java.util.List;
import java.util.stream.Collectors;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Component;

import com.antoniofrische.perifericosAdvisor.model.Periferico;
import com.antoniofrische.perifericosAdvisor.service.PerifericoQueryService;
import com.antoniofrische.perifericosAdvisor.service.PerifericoService;

@Component
public class PerifericoAdvisorRunApp {

	@Autowired
	PerifericoService perifericoService;
	
	@Autowired
	PerifericoQueryService perifericoQueryService;

	@Autowired
	PerifericoAdvisorHelp help;

	public void run(String[] args) {

		if (args.length < 1) {
			System.out.println("Error de sintaxis");
			System.out.println(help.getHelp());
		} else if (args.length == 1) {
			switch (args[0].toLowerCase()) {
			case "-lg":
				perifericoService.findAllTipo().forEach(System.out::println);
				break;
			case "-h":
				System.out.println(help.getHelp());
				break;
			default:
				System.out.println("Error de sintaxis");
				System.out.println(help.getHelp());

			}
		} else if (args.length % 2 != 0) {
			System.out.println("Error de sintaxis");
			System.out.println(help.getHelp());
		} else if (args.length > 8) {
			System.out.println("Error de sintaxis");
			System.out.println(help.getHelp());
		} else {

			List<String[]> argumentos = new ArrayList<>();

			for (int i = 0; i < args.length; i += 2) {
				argumentos.add(new String[] { args[i], args[i + 1] });
			}
			
			boolean error = false;

			for (String[] argumento : argumentos) {
				switch (argumento[0].toLowerCase()) {
				case "-at":
					perifericoQueryService.anyTipo(argumento[1].split(","));
					break;
				case "-tt":
					perifericoQueryService.allTipo(argumento[1].split(","));
					break;
				case "-c":
					perifericoQueryService.color(null);
					break;
				case "-t":
					perifericoQueryService.titleContains(argumento[1]);
					break;
				default: error = true;
						 System.out.println("Error de sintaxis");
						 System.out.println(help.getHelp());
				}

			}
			
			if (!error) {
				Collection<Periferico> result = perifericoQueryService.exec();
				System.out.printf("%s\t%-50s\t%s\t%s\n","ID","Título", "Año", "Géneros");
				if (result != null) {
					result.forEach(f -> System.out.printf("%s\t%-50s\t%s\t%s\n", 
							f.getId(), f.getNombre(), f.getColor(), 
							f.getTipo().strip().collect(Collectors.joining(", "))));
				} else {
					System.out.println("No hay películas que cumplan esos criterios. Lo sentimos");
				}
			}
		}

	}

}
