package com.antoniofrische.perifericosAdvisor.dao;

import java.util.ArrayList;
import java.util.Collection;
import java.util.List;
import java.util.Optional;


import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Repository;

import com.antoniofrische.perifericosAdvisor.config.AppConfig;
import com.antoniofrische.perifericosAdvisor.model.Periferico;

@Repository
public class PerifericoDaoImplMemory implements PerifericoDao {
	
	public List<Periferico> perifericos = new ArrayList<Periferico>();
	
	@Autowired
	private AppConfig appConfig;
	
	public void init() {
		perifericos = UtilPerifericoFileReader.readFile(appConfig.getFile(), appConfig.getSeparator(), appConfig.getListSeparator());
	}

	public Periferico findById(long id) {
		
		Optional<Periferico> result = perifericos
									.stream()
									.filter(f -> f.getId() == id)
									.findFirst();
		return result.orElse(null);
		
		
	}

	public Collection<Periferico> findAll() {		
		return perifericos;
	}

	public void insert(Periferico periferico) {
		perifericos.add(periferico);
	}

	public void edit(Periferico periferico) {
		int index = getIndexOf(periferico.getId());
		if (index != -1)
			perifericos.set(index, periferico);
	}

	public void delete(long id) {
		int index = getIndexOf(id);
		if (index != -1)
			perifericos.remove(index);

	}
	
	private int getIndexOf(long id) {
		boolean encontrado = false;
		int index = 0;
		
		while (!encontrado && index < perifericos.size()) {
			if (perifericos.get(index).getId() == id)
				encontrado = true;
			else
				index++;
		}
		
		return (encontrado) ? index : -1;
	}

}
